' ********************************************************************
' **  Sample PlayVideo App
' **  Copyright (c) 2009 Roku Inc. All Rights Reserved.
' ********************************************************************


'*************************************************************
'** displayVideo()
'*************************************************************

Function displayVideo(videoItem as Object) As Integer
    print "Displaying video: ";videoItem
    p = CreateObject("roMessagePort")
    video = CreateObject("roVideoScreen")
    video.setMessagePort(p)

    'bitrates  = [0]          ' 0 = no dots, adaptive bitrate
    'bitrates  = [348]    ' <500 Kbps = 1 dot
    'bitrates  = [664]    ' <800 Kbps = 2 dots
    'bitrates  = [996]    ' <1.1Mbps  = 3 dots
    'bitrates  = [2048]    ' >=1.1Mbps = 4 dots
    bitrates  = [0]    

    'Swap the commented values below to play different video clips...
    'urls = ["http://cdn.expressplay.com/video/helloworld.mp4"]
    urls = [""]
    qualities = ["HD"]
    StreamFormat = "mp4"
    title = "Missing URL"
    srt = ""

    if type(videoItem) = "roAssociativeArray"
        if (type(videoItem.url) = "roString" or type(videoItem.url) = "String") and videoItem.url <> "" then
            print "playing ";videoItem.url
            urls[0] = videoItem.url
        end if
        if (type(videoItem.StreamFormat) = "roString" or type(videoItem.StreamFormat) = "String") and videoItem.StreamFormat <> "" then
            StreamFormat = videoItem.StreamFormat
        end if
        if (type(videoItem.title) = "roString" or type(videoItem.title) = "String") and videoItem.title <> "" then
            title = videoItem.title
        else 
            title = ""
        end if
        if (type(videoItem.srt) = "roString" or type(videoItem.srt) = "String") and videoItem.srt <> "" then
            srt = videoItem.StreamFormat
        else 
            srt = ""
        end if
    end if
    
    videoclip = CreateObject("roAssociativeArray")
    videoclip.StreamBitrates = bitrates
    videoclip.StreamUrls = urls
    videoclip.StreamQualities = qualities
    videoclip.StreamFormat = StreamFormat
    videoclip.Title = title
    print "srt = ";srt
    if srt <> invalid and srt <> "" then
        videoclip.SubtitleUrl = srt
    end if
    
    video.SetContent(videoclip)
    video.show()

    lastSavedPos   = 0
    statusInterval = 10 'position must change by more than this number of seconds before saving

    while true
        msg = wait(0, video.GetMessagePort())
        if type(msg) = "roVideoScreenEvent"
            if msg.isScreenClosed() then 'ScreenClosed event
                print "Closing video screen"
                exit while
            else if msg.isPlaybackPosition() then
                nowpos = msg.GetIndex()
                if nowpos > 10000
                    
                end if
                if nowpos > 0
                    if abs(nowpos - lastSavedPos) > statusInterval
                        lastSavedPos = nowpos
                    end if
                end if
            else if msg.isRequestFailed()
                print "play failed: "; msg.GetMessage()
            else
                print "Unknown event: "; msg.GetType(); " msg: "; msg.GetMessage()
            endif
        end if
    end while

    return 1

End Function

